//+------------------------------------------------------------------+
//|                                                  MACD Sample.mq4 |
//|                   Copyright 2005-2014, MetaQuotes Software Corp. |
//|                                              http://www.mql4.com |
//+------------------------------------------------------------------+
#property copyright   "2005-2014, MetaQuotes Software Corp."
#property link        "http://www.mql4.com"
#include <customfunctions01.mqh>
input double TakeProfit    =500;
input double OrderStopLoss = 100;
input double Lots          =0.5;
input double TrailingStop  =500;
input double MACDOpenLevel =3;
//input double MACDCloseLevel=2;
//input int    MATrendPeriod =26;
input double rsiPeriod = 7;
input int  SlowMA = 200;
input int FastMA = 50;
int magicNB = 55555;
//int rsiPeriod = 7;
input double riskPerTrade = 0.02;
input int rsiLowerLevel = 20;
input int rsiUpperLevel = 80;

//input int stoplosspips = 100;

input int takeprofitpips = 500;
input int breakeven = 40;
//input int SlowMA = 200;
//input int FastMA = 50;
input int StoUpperlevel = 80;
input int StoLowerLevel = 20;
//double  OrderStopLoss = 100;
bool isnewcandle;


int openOrderID;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick(void)
  {
  // double MacdCurrent,MacdPrevious;
  // double SignalCurrent,SignalPrevious;
 //  double MaCurrent,MaPrevious;
   int    cnt,ticket,total;
//---
// initial data checks
// it is important to make sure that the expert works with a normal
// chart and the user did not make any mistakes setting external 
// variables (Lots, StopLoss, TakeProfit, 
// TrailingStop) in our case, we check TakeProfit
// on a chart of less than 100 bars
//---
 if(Bars<0)
    {
    Print("bars less than 0");
    return;
  }
    
    if (isnewcandle)
  // if(TakeProfit>500)
   {
     Print("TakeProfit less than 100");
      return;
     }
//--- to simplify the coding and speed up access data are put into internal variables
    double FastMA = iMA(NULL,0,50,0,MODE_SMA,PRICE_CLOSE,0);
   double SlowMA= iMA(NULL,0,200,0,MODE_SMA,PRICE_CLOSE,1);
   double rsiValue = iRSI(NULL,0,rsiPeriod,PRICE_CLOSE,0);
 double currentRSI = iRSI(NULL,0,7,0,0);
   double previousRSI = iRSI(NULL,0,7,0,5);
   double Stovalue = iStochastic(NULL, 0, 14 , 3, 3, MODE_SMA, MODE_MAIN, 0, 0);
   double currentStovalue = iStochastic(NULL, 0, 14 , 3, 3, MODE_SMA, MODE_MAIN, 0, 0);
   double previousStovalue = iStochastic (NULL, 0, 14 , 3, 3, MODE_SMA, MODE_MAIN, 0, 1);
  // double MACD = iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,0);
   
 
   total=OrdersTotal();
   if(total<1)
    {
      //--- no opened orders identified
     if(AccountFreeMargin()<(1000*Lots))
        {
        Print("We have no money. Free Margin = ",AccountFreeMargin());
        return;
       }
      //--- check for long position (BUY) possibility
      if (rsiValue<20 &&  FastMA>SlowMA&& Stovalue< 20 && Ask<SlowMA) //buying
        {
        
        
         Print("MA's show a bullish market and rsiValue is lower than " + rsiLowerLevel+ " , Sending buy order");
       double stopLossPrice = OrderStopLoss;             //Ask - OrderStopLoss * GetPipValue();
         double takeProfitPrice = TakeProfit;                      //Ask + takeprofitpips * GetPipValue();
         Print("Entry Price = " + Ask);
         Print("Stop Loss Price = " + OrderStopLoss);
       Print("Take Profit Price = " + takeProfitPrice);
         
         double lotSize = OptimalLotSize(riskPerTrade,Ask,stopLossPrice);
         
       openOrderID = OrderSend(NULL,OP_BUY,lotSize,Ask,10,OrderStopLoss,TakeProfit,NULL,magicNB);
        if(openOrderID < 0) Alert("order rejected. Order error: " + GetLastError());
   
   
    
   
   
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"macd sample",16384,0,Green);
         
         
        if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
             Print("BUY order opened : ",OrderOpenPrice());
           }
         else
            Print("Error opening BUY order : ",GetLastError());
         return;
        }
      //--- check for short position (SELL) possibility
      if (rsiValue > 80  &&  SlowMA>FastMA&& Stovalue>80  && Bid>SlowMA )//shorting
       {
       
   

       
       
       
        ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"macd sample",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES))
               Print("SELL order opened : ",OrderOpenPrice());
           }
        else
            Print("Error opening SELL order : ",GetLastError());
       }
      //--- exit from the "no opened orders" block
      return;
     }
//--- EXITS 
 for(cnt=0;cnt<total;cnt++)
     
     if(!OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
         continue;
     if(OrderType()<=OP_SELL &&   // check for opened position 
       OrderSymbol()==Symbol())  // check for symbol
      {
         //--- long position is opened
         
         
         
        if(OrderType()==OP_BUY)
           {
            //--- should it be closed?
         if (SlowMA>FastMA)
        // if (Bid== OrderStopLoss) NOT WORKING
              {
               //--- close order and exit
              if(!OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet))
                Print("OrderClose error ",GetLastError());
               return;
               
               
               //else // go to short position
              if(OrderType()==OP_SELL)
            //--- should it be closed?
          if (FastMA>SlowMA)
         // if (Ask== OrderStopLoss) NOT WORKING
            {
               //--- close order and exit
           if(!OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet))
             Print("OrderClose error ",GetLastError());
              return;
           }
               
               }
               }
              } 
             }
         